Subject: Re: [RFC PATCH 0/2] rx zero copy interface for af_packet

From: Sowmini Varadhan <[email-masked]>
Date: Tue, 31 Jan 2017 11:30:42 -0500

On (01/27/17 13:33), John Fastabend wrote:
> 
> This is an experimental implementation of rx zero copy for af_packet.
> Its a bit rough and likely has errors but the plan is to clean it up
> over the next few months.
> 
> And seeing I said I would post it in another thread a few days back
> here it is.

One question/comment about this: sure, this saves us an skb copy
on the rx side, but at least for the Tx side, I think there may
be a trade-off between the overhead from the skb setup and the
ease of offloading checksum (and UFO where it is available) to
consider, even for PF_PACKET.

Using PF_PACKET works well for stateless datagram protocols like 
UDP, and for UDP sockets, we find that just switching to Jumbo
(to simulate a poor-man's-UFO) gives us significant improvement
in both throughput and latency for our RDBMS workloads - and 
having the sk_buff facilitates using existing driver-kernel interfaces
for offload easily, so while we may gain some perf improvment by shaving
of the sk_buff overhead, the trade-off needs to be considered.

--Sowmini